**********************************************************
*                      TAPE1.SAS                        *
*                                                        *
*  Ce programme permet de crer le fichier de donnes    *
*  SAS contenant les variables ncessaires pour utiliser *
*  le programme BOOTVARF_V20.SAS                         *
**********************************************************;


LIBNAME in1 'nom_du_rpertoire_o_sauvegarder_le fichier';


*** Cration du fichier de donnes SAS contenant les variables et enregistrements requis 
*** pour l'analyse.  Ce fichier devrait tre le plus petit possible (contenant seulement 
*** les variables et enregistrements ncessaires) afin de rduire le temps d'excution et  
*** la mmoire requise, spcialement dans le cas des rgressions. ;
 

data in1.nom_du_fichier_d''analyse;       /* Fichier qui sera utilis avec BOOTVARF_V20.SAS */
   %let datafid="location_et_nom_du_fichier_source";
   %include "location_et_nom_du_clich_d'article";


***  Cration des variables dichotomiques    ***
*** (des exemples sont prsents ci-dessous, utilisant les variables de l'ENSP, cycle 3) ***;
            
   /* diabte */
          if ccc8_1j=1 then diab=1;
          else diab=0;

   /* sexe */
          if dhc8_sex=1 then hommes=1;
          else hommes=0;
          if dhc8_sex=2 then femmes=1;
          else femmes=0;

   /* diabte*sexe */
          hdiab = diab * hommes;    /* hommes diabtiques */
          fdiab = diab * femmes;    /* femmes diabtiques */


     keep liste des variables  conserver;

                * Il est recommand de ne conserver que les variables ncessaire        *
                * afin de diminuer le temps d'excution du programme BOOTVARF_V20.SAS.  *
                * IMPORTANT:  les variables d'identification et, si ncessaire, la(les) *
                * variable(s) de ventilation (ex: provinces, sexe) doivent tre         *
                * conserves.   La variable de poids doit aussi tre conserve si les   *
                * estimations ponctuelles sont calcules  cette tape.                 *;
             
run;



******************************************
* Calcul des estimations ponctuelles     *
* Conseill, mais non obligatoire...     *
******************************************;


proc freq data=in1.nom_du_fichier_d''analyse;
     table variables dsires;
     weight variable_de_poids;
run;

proc logistic data=in1.nom_du_fichier_d''analyse;
     model variable_dpendante = variables indpendantes;
     weight variable_de_poids;
run;